;;; $Id: binary-tree-of-num.scm,v 1.3 1998/10/07 19:39:43 leavens Exp $

(define-record interior (symbol left-tree right-tree))

(define leaf?
  ;; TYPE: (-> (tree) boolean)
  number?)
  
(define make-leaf
  ;; TYPE: (-> (number) tree)
  (lambda (n) n))

(define leaf->number
  ;; TYPE: (-> (tree) number)
  (lambda (bt)
    (if (number? bt)
	bt
	(error "leaf->number passed a non-number" bt))))

(define tree?
  ;; TYPE: (-> (datum) boolean)
  (lambda (x)
    (or (number? x)
	(and (interior? x)
	     (symbol? (interior->symbol x))
	     (tree? (interior->left-tree x))
	     (tree? (interior->right-tree x))))))
