;;; $Id: ch5-1-4-denoted-value.scm,v 1.3 1998/10/26 21:34:10 leavens Exp $

(load-quietly-from-lib "inject-extract.scm")

(define number->denoted
  ;; TYPE: (-> (number) Denoted-Value)
  inject)

(define procedure->denoted
  ;; TYPE: (-> (Procedure) Denoted-Value)
  inject)

(define list->denoted
  ;; TYPE: (-> (Procedure) Denoted-Value)
  inject)

(define ch5-1-4-denoted-value:extract
  ;; TYPE: (-> ((-> (Denoted-Value) boolean) string) (-> (T) T))
  (extract-maker "denoted"))

(define denoted->number
  ;; TYPE: (-> (Denoted-Value) number)
  (ch5-1-4-denoted-value:extract number? "number"))

(define denoted->procedure
  ;; TYPE: (-> (Denoted-Value) Procedure)
  (ch5-1-4-denoted-value:extract prim-proc? "procedure"))

(define denoted->list
  ;; TYPE: (-> (Expressed-Value) (list Expressed-Value))
  (ch5-1-4-denoted-value:extract (lambda (x) (or (pair? x) (null? x)))
				 "list"))
