;;; $Id: ch5-1-denoted-value.scm,v 1.3 1998/10/16 03:07:44 leavens Exp $

(load-quietly-from-lib "inject-extract.scm")

(define number->denoted
  ;; TYPE: (-> (number) Denoted-Value)
  inject)

(define procedure->denoted
  ;; TYPE: (-> (Procedure) Denoted-Value)
  inject)

(define ch5-1-denoted-value:extract
  ;; TYPE: (-> ((-> (Denoted-Value) boolean) string) (-> (T) T))
  (extract-maker "denoted"))

(define denoted->number
  ;; TYPE: (-> (Denoted-Value) number)
  (ch5-1-denoted-value:extract number? "number"))

(define denoted->procedure
  ;; TYPE: (-> (Denoted-Value) Procedure)
  (ch5-1-denoted-value:extract prim-proc? "procedure"))
