;;; $Id: ch5-1-expressed-value.scm,v 1.1 1998/10/16 03:08:03 leavens Exp $

(load-quietly-from-lib "inject-extract.scm")

(define number->expressed
  ;; TYPE: (-> (number) Expressed-Value)
  inject)

(define procedure->expressed
  ;; TYPE: (-> (Procedure) Expressed-Value)
  inject)

(define ch5-1-expressed-value:extract
  ;; TYPE: (-> ((-> (Expressed-Value) boolean) string) (-> (T) T))
  (extract-maker "expressed"))

(define expressed->number
  ;; TYPE: (-> (Expressed-Value) number)
  (ch5-1-expressed-value:extract number? "number"))

(define expressed->procedure
  ;; TYPE: (-> (Expressed-Value) Procedure)
  (ch5-1-expressed-value:extract prim-proc? "procedure"))

(define denoted->expressed
  ;; TYPE: (-> (Denoted-Value) Expressed-Value)
  (lambda (dv) dv))

(define expressed->denoted
  ;; TYPE: (-> (Expressed-Value) Denoted-Value)
  (lambda (ev) ev))

