;;; $Id: ch5-4.tst,v 1.1 1999/04/25 16:23:52 leavens Exp $

(load-quietly-from-lib "run.scm")

(run-regression-tests-equal?
 `(
    ( (run "+(2,3)")
      ==> 5 )
    ( (run "+")
      ==> ,(make-prim-proc '+) )
    ( (run "add1(*(3,-(7,2)))")
      ==> 16 )
    ( (run "sub1(343)")
      ==> 342 )
    ( (run "if 0 then 5 else 4")
      ==> 4 )
    ( (run "if +(1,0) then 5 else 4")
      ==> 5 )
    ( (run "let x = 5; y = 6 in +(x, y)")
      ==> 11 )
    ( (run "let x = 3 in let x = *(x, x) in +(x, x)")
      ==> 18 )
    ( (run "let f = sub1; seven = 7
            in let five = -(seven, 2); seven = 3
               in f(five)")
      ==> 4 )
    ( (run "let sum3 = proc (a, b, c) +(a, +(b, c))
            in sum3(3, 4, 2)")
      ==> 9 )
    ( (run "(proc (a,b,c) +(a, +(b,c)))(3, 4, 2)")
      ==> 9 )
    ( (run "let x = 5
            in let addx = proc (i) +(i, x);
                   x = 41
               in addx(3)")
      ==> 8 )
    )
 )
