;;; $Id: fix.scm,v 1.2 1999/02/11 19:45:49 leavens Exp $

;;; The following is quite useful for taking fixed points in Scheme,
;;; even though it's defined recursively, and so it's not a combinator.
;;; See the file y.scm for the usual fix-point combinators.
;;; Note that fix can handle multiple-argument functions.
(define fix
  ;; TYPE: (-> ((-> ((-> (S ...) T)) (-> (S ...) T)))
  ;;           (-> (S ...) T))
  (lambda (G)
    (lambda args
      (apply (G (fix G)) args))))

(define Y fix)
