;; $Id: memo.scm,v 1.1 1998/11/12 22:53:20 leavens Exp $

(load-quietly-from-lib "cell.scm")

;;; Anonymous figure : page 207

(define-record memo-rep (cell))

(define memo? memo-rep?)

(define memo-remember
  ;; TYPE: (-> ((-> () T)) (memo T))
  (lambda (thnk)
    (make-memo-rep (make-cell thnk))))

(define memo-retrieve
  ;; TYPE: (-> ((memo T)) T)
  (lambda (m)
    (variant-case m
      (memo-rep (cell)
	 (let ((contents (cell-ref cell)))
	   (if (procedure? contents)
	       (let ((val (contents)))
		 (if (not (procedure? val))
		     (begin
		       (cell-set! cell val)
		       val)
		     (error "value of this memo is a procedure!" contents)))
	       contents)))
      (else (error "bad argument to memo-retrieve:" m)))))
