;;; $Id: monad-identity.scm,v 1.1 1999/08/11 16:22:59 leavens Exp $
;;; The identity monad
;;;     (Identity T) = T
;;; adapted from
;;; Wadler's paper "The Essence of Functional Programming", section 2.2

(define return-id
  ; TYPE: (-> (T) (Identity T))
  (lambda (a) a))

(define bind-id
  ; TYPE: (-> ((Identity T) (-> (T) (Identity U))) (Identity U))
  (lambda (a k) (k a)))

(define show-id
  ; TYPE: (-> ((Identity T)) T)
  (lambda (a) a))
