;;; $Id: parsed-form.scm,v 1.2 1998/11/04 22:01:09 leavens Exp $
;;; Abstract syntax for the defined language's forms

(load-quietly-from-lib "inject-extract.scm")

(define-record define (var exp))
(define-record definearray (var len-exp))

(define parsed-exp?
  ;; TYPE: (-> (parsed-form) boolean)
  (lambda (pf)
    (not (or (define? pf) (definearray? pf)))))

(define exp->form
  ;; TYPE: (-> (parsed-exp) parsed-form)
  inject)

(define parsed-form:extract
  ;; TYPE: (-> ((-> (parsed-form) boolean) string) (-> (T) T))
  (extract-maker "form"))

(define form->exp
  ;; TYPE: (-> (parsed-form) parsed-exp)
  (parsed-form:extract parsed-exp? "exp"))
