;; $Id: run.scm,v 1.14 1998/10/26 16:40:40 leavens Exp $
;; The run procedure from EOPL, with environments and syntax-expand.
;; This uses the character string parser.

;; Note: you have to define eval-form, eval-exp, and syntax-expand
;; before using this!

;; The procedure eval-form calls syntax-expand,
;; and passes the result to eval-exp;
;; eval-form may handle such top-level forms as define.

(load-quietly-from-lib "undefine-read-eval-print.scm")
(load-from-lib "char-parser-connections.scm")

;; the real thing

(define run
  ;; TYPE: (-> (<form>) Expressed-Value)
  (lambda (x)
    (eval-form (parse x))))
