;; $Id: rep5-1.scm,v 1.8 1998/11/04 22:22:32 leavens Exp $

;; The read-eval-print loop from EOPL Appendix F, adapted for section 5.1

(load-quietly-from-lib "undefine-run.scm")

;; the real thing

(load-from-lib "appendix-f.scm")

;;; Grammar for forms (user input):
;;;   <form> ::= <exp>
;;; These forms are a complication that result from using the same parser
;;; for many sections of this chapter.  We need to do a type conversion here
;;; to satisfy the type checker.

;;; override of App. F for sections 5.1-2
(define eval-print
  ;; TYPE: (-> (parsed-form) void)
  (lambda (tree)
    (write (eval-exp (form->exp tree)))))
