;; $Id: ribassoc.scm,v 1.5 1998/10/06 23:16:26 leavens Exp $

(load-quietly-from-lib "list-index.scm")

(define cs342:ribassoc
  ;; TYPE: (-> (symbol (list symbol) (vector T) T) T)
  (lambda (s los v fail-value)
    ;; REQUIRES: (length los) = (vector-length v)
    ;; ENSURES: if s occurs in los and its first occurence has index i,
    ;; then result is the ith element of v; otherwise the result is fail-value.
   (let ((f (cs342:list-index s los)))
     (if (> f -1)
	 (vector-ref v f)
	 fail-value))))

(define ribassoc cs342:ribassoc)
