;;; $Id: seq-proc.scm,v 1.1 1998/10/08 01:57:02 leavens Exp $

;;; INFINITE SEQUENCS AS PROCEDURES

(define seq-repeat
  ;; TYPE: (-> (number) seq)
  (lambda (num)
    (lambda (n) num)))

(define seq-generator
  ;; TYPE: (-> ((-> (number) number)) seq)
  (lambda (f)
    (lambda (n) (f n))))

(define seq-nth
  ;; TYPE: (-> (seq number) number)
  (lambda (seq n)
    (seq n)))

(define seq-add
  ;; TYPE: (-> (seq seq) seq)
  (lambda (s1 s2)
    (lambda (n)
      (+ (s1 n) (s2 n)))))
